//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main()
{
  list<int> coll;

  INSERT_ELEMENTS(coll,1,9);
  INSERT_ELEMENTS(coll,1,9);
  coll.sort ();
  PRINT_ELEMENTS(coll," :\n");

  //     ,    
  //     5
  list<int>::iterator pos1, pos2;

  pos1 = lower_bound (coll.begin(), coll.end(),
                      5);
  pos2 = upper_bound (coll.begin(), coll.end(),
                      5);
  cout << ToRus(" 5     ")
       << distance(coll.begin(),pos1) + 1
       << ToRus("  ")
       << distance(coll.begin(),pos2) + 1
       << ToRus("\n   .") << endl;

  //  3       
  coll.insert (lower_bound(coll.begin(),coll.end(),
                           3),
               3);

  //  7       
  coll.insert (upper_bound(coll.begin(),coll.end(),
                           7),
               7);

  PRINT_ELEMENTS(coll,"   3  7:\n");


  getch();
  return 0;
}

//---------------------------------------------------------------------------